require 'securerandom'
require 'soar/policy/access_manager/model_provider/stub'
require 'soar/policy/access_manager/model'

module Soar
  module Policy
    module AccessManager
      module Test
        module OrchestrationProvider
          class Stub 

            def initialize
              @meta = {
                'service_identifier1' => {
                  'policy' => 'policy1'
                }
              }
              @policies = {
                'policy1' => {
                  'resource_identifier1' => ['authentication_identifier1'],
                  'resource_identifier2' => []
                }
              }
              @request = {
                params: {},
                authentication_identifier: 'authentication_identifier1'
              }
            end

            def grant_access
              @service_identifier = 'service_identifier1'
              @resource_identifier = 'resource_identifier1'
            end

            def deny_access
              @service_identifier = 'service_identifier1'
              @resource_identifier = 'resource_identifier2'
            end

            def no_policy
              @service_identifier = 'service_identifier2'
              @resource_identifier = nil
            end

            def notification
              @response['data']['notifications']
            end

            def authorized?
              model_provider = Soar::Policy::AccessManager::ModelProvider::Stub.new(meta: @meta, policies: @policies)
              model = Soar::Policy::AccessManager::Model.new(model_provider)
              @response = model.authorized?(service_identifier: @service_identifier, resource_identifier: @resource_identifier, request: @request)
            end

            def authorized
              @response['data']['approved']
            end

          end
        end
      end
    end
  end
end
